/*
 * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

package example.entity;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import java.util.Collection;
import java.util.ArrayList;

/**
 * @author Mitesh Meswani
 */
@Entity
public class Department {
    @Id
    private int id;
    private String name;
    @OneToMany(mappedBy = "department")
    private Collection<Employee> employees = new ArrayList<Employee>();

    public Department(int id, String name) {
        this.id = id;
        this.name = name;
    }

    //To satisfy JPA requirement of having protected or public no arg ctor
    protected Department() {
    }


    @Override public String toString() {
        return "Department : Id = " + id + " : Name = " + name + " :";
    }

    public Collection<Employee> getEmployees() {
        return employees;
    }

    public void addEmployee(Employee e) {
        employees.add(e);
    }

    public void removeEmployee(Employee e) {
        employees.remove(e);
    }

}
