/*
 * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

package example.entity;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.FetchType;

/**
 * @author Mitesh Meswani
 */
@Entity
public class Employee {
    @Id
    private int id;

    private String name;

    @ManyToOne(fetch = FetchType.LAZY)
    private Department department;

    //To satisfy JPA requirement of having protected or public no arg ctor 
    protected Employee() {
    }

    public Employee(int id, String name) {
        this.id = id;
        this.name = name;
    }

    @Override public String toString() {
        return "Employee : Id = " + id + " : Name = " + name + " :";    
    }

    // Manage releationship from owner side
    public void setDepartment(Department d) {
        if(department != null) {
            department.removeEmployee(this);
        }
        if(d != null) {
            d.addEmployee(this);
        }
        this.department = d;
    }

    public Department getDepartment() {
        return department;
    }

}
