/*
 * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

package example.servlet;

import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

/**
 * @author Mitesh Meswani
 */
public class ContextListner implements ServletContextListener {

    static final String ATTRIBUTE_EMF = "ATTRIBUTE_EMF";
    static {
        System.out.println("****Entering static block of ContextListner - classloader is " + ContextListner.class.getClassLoader());
    }
	
    public void contextInitialized(ServletContextEvent event) {
        System.out.println("*****Creating emf....*****");
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("pujavase");
        event.getServletContext().setAttribute(ATTRIBUTE_EMF, emf);
    }

    public void contextDestroyed(ServletContextEvent event) {
        System.out.println("*****Destroying emf....****");
        EntityManagerFactory emf = (EntityManagerFactory) event.getServletContext().getAttribute(ATTRIBUTE_EMF);
        emf.close();
    }
}
