package example.servlet;

import example.entity.UserCredential;
import example.entity.Department;
import example.entity.Employee;

import javax.annotation.Resource;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.PersistenceUnit;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;
import java.io.IOException;
import java.io.PrintWriter;

public class CreateEmpDeptData extends HttpServlet {

    // This injects the default entity manager factory
    @PersistenceUnit(unitName = "pujavaee")
    private EntityManagerFactory emf;

    // This injects a user transaction object.
    @Resource
    private UserTransaction utx;

    public void service (HttpServletRequest req , HttpServletResponse resp)
                    throws ServletException, IOException {

        // create an entity manager in service() so that only
        // this thread uses it.
        // More over, we create EM after utx.begin(), so that we don't
        // have to call em.joinTransaction().
        EntityManager em = emf.createEntityManager();

        try {
            resp.setContentType("text/html");
            PrintWriter out = resp.getWriter();
            out.println("<HTML> <HEAD> <TITLE>Creating Employee Department Data " +
                        "</TITLE> </HEAD> <BODY BGCOLOR=white>");

            Department dept = new Department(10, "dept1");
            Employee emp = new Employee (1, "emp1");
            emp.setDepartment(dept);

            utx.begin();
            em.joinTransaction();
            em.persist(dept);
            em.persist(emp);
            utx.commit();

            out.println("Successfully created Emp Dept data. " +
                            emp + '\n' +
                            dept);
            out.println("</BODY> </HTML> ");

//            // commit the transaction,
//            // b'cos web container rollbacks unfinished tx at the end of request
//            utx.commit();
        } catch (Exception e) {
//            try {
//                utx.rollback();
//            } catch (Exception ee) {
//                // log the exception and continue
//            }
            throw new ServletException(e);
        } finally {
            // close the em so that provider can release resources.
            em.close();
        }
    }

    public void  init( ServletConfig config) throws ServletException {
        super.init(config);
//        ServletContext context = config.getServletContext();
//        emf = (EntityManagerFactory) context.getAttribute(ContextListner.ATTRIBUTE_EMF);
//        if(emf == null) {
//            emf = Persistence.createEntityManagerFactory("pu1");
//            context.setAttribute(ContextListner.ATTRIBUTE_EMF, emf);
//
//        }
    }

}