package example.servlet;

import example.entity.UserCredential;

import javax.annotation.Resource;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.PersistenceUnit;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;
import java.io.IOException;
import java.io.PrintWriter;

public class RegistrationServletJavaSE extends HttpServlet {

    private EntityManagerFactory emf;

    public void service (HttpServletRequest req , HttpServletResponse resp)
                    throws ServletException, IOException {

        // create an entity manager in service() so that only
        // this thread uses it.
        // More over, we create EM after utx.begin(), so that we don't
        // have to call em.joinTransaction().
        EntityManager em = emf.createEntityManager();

        try {
            resp.setContentType("text/html");
            PrintWriter out = resp.getWriter();
            out.println("<HTML> <HEAD> <TITLE>New User Registartion " +
                        "</TITLE> </HEAD> <BODY BGCOLOR=white>");

            String name = req.getParameter("name");
            String password = req.getParameter("password");

            if(name == null) {
                out.println("Call the servlet using param name and password For example http://localhost:8080/basicwebapp/registrationse&name=foo&password=bar");
                return;
            }

            UserCredential credential = new UserCredential(name, password);

            // em.persist makes the new object as persistent and managed.
            em.getTransaction().begin();
            em.persist(credential);
            em.getTransaction().commit();

            out.println("Successfully created the new user. " +
                            "Click <A HREF=\"login.html\"> here </A> to login.");
            out.println("</BODY> </HTML> ");

//            // commit the transaction,
//            // b'cos web container rollbacks unfinished tx at the end of request
//            utx.commit();
        } catch (Exception e) {
//            try {
//                utx.rollback();
//            } catch (Exception ee) {
//                // log the exception and continue
//            }
            throw new ServletException(e);
        } finally {
            // close the em so that provider can release resources.
            em.close();
        }
    }

    @Override public void  init( ServletConfig config) throws ServletException {
        super.init(config);
        ServletContext context = config.getServletContext();
        emf = (EntityManagerFactory) context.getAttribute(ContextListner.ATTRIBUTE_EMF);
        if(emf == null) {
            emf = Persistence.createEntityManagerFactory("pujavase");
            context.setAttribute(ContextListner.ATTRIBUTE_EMF, emf);

        }
    }

    public void  destory() throws ServletException {
        if(emf != null && emf.isOpen()) {
            emf.close();
        }
    }


}